#include <PA9.h>
#include <math.h>

#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"

/* DLDI */
#include <fat.h>
#define FILEGAME "/kukulcan/20.sav" //nom de la sauvegarde
u8 isDLDISystem = 0;

char txtVIDE[33] = {"                                "};
char txtLIG1[33] = {"        r       r       r       "};
char txtLIG2[33] = {"sssssssstssssssstssssssstsssssss"};


/* Pour le jeu */
#define JEU_COLS 4
#define JEU_ROWS 6
#define TOTALTOUILLER 500
#define NBWORLD 20
u16 totalmelange = 0;

s8 WORLD = 0;
s8 LEVEL = 0;
u8 TOTALGOOD = 0;
u8 MonTableau64[JEU_COLS][JEU_ROWS] = {};

u8 startmenu = 0;
s8 gallery = 0;
u8 bg_grille = 0;//masqu
u8 bg_info = 1;//visible

/* position de la case vide */
u8 casex = 0;
u8 casey = 0;

/* POUR LA CONVERTION */
u32 ImageEntiereJPEG[128*384];//128 et non 256 en largeur car on bosse en 32bits ce qui veux dire qu'on a 2pixels par valeur
u32 elements_vide[96*192] = {};//9 elements en 64x64 (192x192)
u32 preview_pack[80*88] = {};//image (160x88)

#include "sons.h"
#include "fonctions.h"
#include "effets.h"
#include "background_jeu.h"
#include "background_prs.h"
#include "jeu.h"
#include "hiscore.h"

u8 view_mycol = 0;
u8 view_myrow = 0;

void aff_fleche_gauche_oui()
{
	PA_OutputSimpleText(0, 1, 1,  "");
	PA_OutputSimpleText(0, 1, 2,  "");
}
void aff_fleche_gauche_non()
{
	PA_OutputSimpleText(0, 1, 1,  "  ");
	PA_OutputSimpleText(0, 1, 2,  "  ");
}
void aff_fleche_droite_oui()
{
	PA_OutputSimpleText(0, 23, 1,  "");
	PA_OutputSimpleText(0, 23, 2,  "");
}
void aff_fleche_droite_non()
{
	PA_OutputSimpleText(0, 23, 1,  "  ");
	PA_OutputSimpleText(0, 23, 2,  "  ");
}
void aff_infos_oui()
{
	PA_OutputSimpleText(0, 25, 12,  "");
	PA_OutputSimpleText(0, 25, 13,  "");
}
void aff_infos_non()
{
	PA_OutputSimpleText(0, 25, 12,  "     ");
	PA_OutputSimpleText(0, 25, 13,  "     ");
}
void aff_game_oui()
{
	PA_OutputSimpleText(0, 26, 17,  "");
	PA_OutputSimpleText(0, 26, 18,  "");
}
void aff_game_non()
{
	PA_OutputSimpleText(0, 26, 17,  "    ");
	PA_OutputSimpleText(0, 26, 18,  "    ");
}
void aff_help_oui()
{
	PA_OutputSimpleText(0, 26,  9,  "");
	PA_OutputSimpleText(0, 26, 10,  "");
}
void aff_help_non()
{
	PA_OutputSimpleText(0, 26,  9,  "    ");
	PA_OutputSimpleText(0, 26, 10,  "    ");
}
void aff_gallery_oui()
{
	PA_OutputSimpleText(0, 25,  4,  "");
	PA_OutputSimpleText(0, 25,  5,  "");
}
void aff_gallery_non()
{
	PA_OutputSimpleText(0, 25,  4,  "      ");
	PA_OutputSimpleText(0, 25,  5,  "      ");
}

char szFile1[256];




void afficher_choix_level()
{
	PA_OutputSimpleText(0, 3, 18, "                    ");//effacer la ligne
	PA_OutputSimpleText(0, 3+LEVEL, 18, "x");//afficher la fleche
}

void change_level()
{
	//24.133
	//183,151
	u8 choixlevelx = (Stylus.X - 24) / 8;
	if (hiscore[WORLD][choixlevelx].ETAT != 0)
	{
		son_clik();
		LEVEL = choixlevelx;
		afficher_choix_level();
	}
	else
	{
		son_bad();
	}
}

void aff_scan_all_level()
{
	u8 i = 0;
	//u = vert (fini)
	//v = orange (unlock mais non fini)
	//w = rouge (lock)

	//colonne 3
	//ligne 17
	for (i=0;i<20;i++)
	{
		if (hiscore[WORLD][i].ETAT == 1)
		{
			//UNLOCK
			PA_OutputSimpleText(0, 3+i, 17, "v");
		}
		else if (hiscore[WORLD][i].ETAT == 2)
		{
			//FINI
			PA_OutputSimpleText(0, 3+i, 17, "u");
		}
		else
		{
			//LOCK
			PA_OutputSimpleText(0, 3+i, 17, "w");
		}
	}
}


//PREVIEW SUR LE MENU
char *MesJPEGpreview[NBWORLD][10]=
{
	{"PACKA_00"},
	{"PACKB_00"},
	{"PACKC_00"},
	{"PACKD_00"},
	{"PACKE_00"},
	{"PACKF_00"},
	{"PACKG_00"},
	{"PACKH_00"},
	{"PACKI_00"},
	{"PACKJ_00"},
	{"PACKK_00"},
	{"PACKL_00"},
	{"PACKM_00"},
	{"PACKN_00"},
	{"PACKO_00"},
	{"PACKP_00"},
	{"PACKQ_00"},
	{"PACKR_00"},
	{"PACKS_00"},
	{"PACKT_00"}
};



void affichage_menubas()
{
	char szFile[256];
	siprintf(szFile,"/kukulcan/20/%s.jpg",MesJPEGpreview[WORLD][0]);
	FILE* file = fopen(szFile, "rb");
	int size;
	u8 *buffer;
	if(file != NULL)
	{
		fseek(file, 0, SEEK_END);
		size = ftell(file);
		fseek(file, 0, SEEK_SET);
		buffer = (u8 *) malloc(size);
		fread(buffer, 1, size, file);
		fclose(file);

		REG_IME = 0x00;//dsactiver la VBL
		JPEG_DecompressImage((void*)buffer,(void*)preview_pack,160,88);
		REG_IME = 0x01;//r-activer la VBL

		free(buffer);
	}

	//afficher
	u32 ecran_depart_x = 24/2;//on doit diviser par 2 (on bosse en 32 bits et double pixel)
	u32 ecran_depart_y = 24;

	u32 etx=0;
	u32 ety=0;
	for (etx=0;etx<80;etx++)
	{
		for (ety=0;ety<88;ety++)
		{
			PA_DrawBg32[0][ecran_depart_x+etx + (ecran_depart_y+ety)*128] = preview_pack[etx+(ety*80)];
		}
	}
	aff_scan_all_level();
	afficher_choix_level();
}

void affichage_menu()
{
	affichage_JPEG_prs(3);
	affichage_menubas();
}



int main(int argc, char ** argv)
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL

	isDLDISystem = fatInitDefault();  // DLDI driver init
	PA_WaitForVBL(); PA_WaitForVBL(); PA_WaitForVBL();
	if (!isDLDISystem)
	{
		while(1);//arrt du prg vu que le systeme de DLDI ne fonctionne pas
	}

	PA_InitSound();
	PA_InitRand();

	PA_InitAllSpriteDraw();  // Inits the sprite draw mode, necessary for the pixel-perfect touch detection

	gestion_musique();


	//*********************************************************************************************************
	//*** LES BG ***
	//**************
	//BG 3
	PA_Init16bitBg(0,3);//ecran, bg priorit (6/8 de la VRAM)
	PA_Init16bitBg(1,3);//ecran, bg priorit (6/8 de la VRAM)

	//BG 2 -> vide

	//BG 1
	bg_grille = 0;//off
	bg_info = 1;//on

	PA_InitCustomText(1, 1, ecran_font); //ecran, background, font name => Chargement d'une font particulire
	PA_InitCustomText(0, 1, ecran_font); //ecran, background, font name => Chargement d'une font particulire

	//BG 0 -> vide


	//charger les 9 cases 64x64 en formes de flches
	REG_IME = 0x00;//dsactiver la VBL
	JPEG_DecompressImage((void*)elements_vide64,(void*)elements_vide,192,192);
	REG_IME = 0x01;//r-activer la VBL

	taillepioche = 0;//pour les effets de prs

	load_hiscore();

	//affichage_JPEG_prs(1);//menu
	LEVEL = 0;
	WORLD = 0;
	gallery = 0;

	if (!Pad.Held.Start)
	{
		affichage_JPEG_prs(4);
		temporisation(240);
	}

	if (Pad.Held.L && Pad.Held.R && Pad.Held.Down)
	{
		//CHEAT CODE
		son_bisou();
		cheat_code();
		Pad.Held.L = false;
		Pad.Held.R = false;
		Pad.Held.Down = false;
	}

	affichage_menu();
	aff_scan_all_level();

	while (1)
	{
		//MENU GENERAL
		startmenu = 2;

		while (startmenu == 2)
		{
			if (Pad.Newpress.X) {gestion_musique(); Pad.Newpress.X = false;}

			if (Stylus.Newpress)
			{
				if ( PA_StylusInZone(24,133,183,151) )
				{
						//CHOIX DU NIVEAU
						change_level();
				}
				else if ( PA_StylusInZone(8,8,31,22) )
				{
					Stylus.X = 0; Stylus.Y = 0;
					Stylus.Newpress = false;
					aff_fleche_gauche_oui();

					//THEME -
					WORLD--;
					if (WORLD < 0)
					{
						WORLD = NBWORLD - 1;
					}
					son_clik();
					//afficher la preview du level
					LEVEL = 0;
					affichage_menubas();
					temporisation(15);
					aff_fleche_gauche_non();
				}
				else if ( PA_StylusInZone(176,8,199,22) )
				{
					Stylus.X = 0; Stylus.Y = 0;
					Stylus.Newpress = false;

					aff_fleche_droite_oui();
					//THEME +
					WORLD++;
					if (WORLD > NBWORLD - 1)
					{
						WORLD = 0;
					}
					son_clik();
					//afficher la preview du level
					LEVEL = 0;
					affichage_menubas();
					temporisation(15);
					aff_fleche_droite_non();
				}


				//*********************************************
				//*** GAME ***
				//************
				if ( PA_StylusInZone(192,136,255,151) )
				{
					aff_game_oui();
					voice_play();
					temporisation(15);
					aff_game_non();

					//ECRAN BAS
					effacer_texte(0);

					startmenu = 3;
					//par dfaut, ds qu'on arrive ici
					//bg_grille = 0 Masqu
					//bg_info = 1 Visible
					bg_grille = 0;
					bg_info = 1;
					TOTALGOOD = 0;

					effacer_texte(1);
					temporisation(20);
					effacer_texte(0);

					PA_OutputText(0, 0, 23, "no");//grille off
					PA_OutputText(0, 2, 23, "##LEVEL#%02d/20###GOOD#%02d/24##fg",LEVEL+1,TOTALGOOD);//ecran, Colonne X, Ligne Y

					melanger_tableau();
					calcul_TOTALGOOD();
					decoupage_JPEG();

					while (startmenu == 3)
					{
						if (Pad.Newpress.X) {gestion_musique(); Pad.Newpress.X = false;}

						if (Stylus.Newpress || Pad.Newpress.Left || Pad.Newpress.Start || Pad.Newpress.Right || Pad.Newpress.L || Pad.Newpress.R || Pad.Newpress.Up || Pad.Newpress.Down || Pad.Newpress.Y)
						{
							if (Pad.Newpress.Up)
							{
								bouger(1);
								Pad.Newpress.Up = false;
								calcul_TOTALGOOD();
							}
							else if (Pad.Newpress.Down)
							{
								bouger(2);
								Pad.Newpress.Down = false;
								calcul_TOTALGOOD();
							}
							else if (Pad.Newpress.Left)
							{
								bouger(3);
								Pad.Newpress.Left = false;
								calcul_TOTALGOOD();
							}
							else if (Pad.Newpress.Right)
							{
								bouger(4);
								Pad.Newpress.Right = false;
								calcul_TOTALGOOD();
							}
							else if (Pad.Newpress.Start || (Stylus.Newpress && PA_StylusInZone(240,184,255,191)) )
							{
								son_quitter();
								Stylus.X = 0; Stylus.Y = 0;
								Pad.Newpress.Start  = false;

								//Quitter
								startmenu = 2;
								bg_grille = 0; masquer_grille();

								if (bg_info == 1) {PA_OutputSimpleText(0, 30, 23, "lm");}
								affichage_menu();//menu
								if (bg_info == 1) {PA_OutputText(0, 0, 23, "%s",txtVIDE);}//ecran, Colonne X, Ligne Y

								bg_info = 1;
							}
							else if (Pad.Newpress.L || (Stylus.Newpress && PA_StylusInZone(0,184,16,191)) )
							{
								son_grille();
								Stylus.X = 0; Stylus.Y = 0;
								Pad.Newpress.L = false;
								if (bg_grille == 0)
								{
									if (bg_info == 1) {PA_OutputText(0, 0, 23, "pq");}
									bg_grille = 1;
									aff_grille();
								}
								else
								{
									if (bg_info == 1) {PA_OutputText(0, 0, 23, "no");}
									bg_grille = 0;
									masquer_grille();
								}
							}
							else if (Pad.Newpress.R)
							{
								son_info();
								Stylus.X = 0; Stylus.Y = 0;
								if (bg_info == 1)
								{
									//devient invisible
									bg_info = 0;
									masquer_info();
								}
								else
								{
									//visible
									bg_info = 1;
									if (bg_grille == 0)
									{
										PA_OutputText(0, 0, 23, "no");//grille off
									}
									else
									{
										PA_OutputText(0, 0, 23, "pq");//grille off
									}
									PA_OutputText(0, 2, 23, "##LEVEL#%02d/20###GOOD#%02d/24##fg",LEVEL+1,TOTALGOOD);//ecran, Colonne X, Ligne Y
								}
								Pad.Newpress.R = false;
							}
							else if (Pad.Held.Y)
							{
								//montrer la vrai image trs rapidement
								for(view_myrow=0;view_myrow<6;view_myrow++)
								{
									for (view_mycol=0;view_mycol<4;view_mycol++)
									{
										afficher_block_prs( (view_myrow*4) + view_mycol);
									}
								}

								while (Pad.Held.Y)
								{
									PA_WaitForVBL();
								}
								//rafficher le niveau comme il tait avant
								for(view_myrow=0;view_myrow<6;view_myrow++)
								{
									for (view_mycol=0;view_mycol<4;view_mycol++)
									{
										afficher_block_jeu(MonTableau64[view_mycol][view_myrow], view_mycol, view_myrow);
									}
								}
								Pad.Held.Y = false;
							}
						}

						if (TOTALGOOD == 24)
						{
							son_gagner();
							//AFFICHER LE NIVEAU EN COMPLET (la case vide doit tre remplac par la bonne case)
							afficher_block_jeu(23, 3, 5);
							attente_ou_touche(180);//3s

							//Niveau Fini
							hiscore[WORLD][LEVEL].ETAT = 2;//niveau fini
							//Niveau suivant
							LEVEL++;
							if (LEVEL > LEVELMAX - 1)
							{
								LEVEL--;
								//Dernier niveau fini - ecran CONGRATULATION
								effacer_texte(1);
								effacer_texte(0);
								affichage_JPEG_prs(2);//BRAVO
								pause();
								son_bisou();
								//Quitter
								startmenu = 2;
								bg_grille = 0; masquer_grille();
								bg_info = 1;
								affichage_menu();//menu
							}
							else
							{
								hiscore[WORLD][LEVEL].ETAT = 1;//ACCES (vide)
								melanger_tableau();
								TOTALGOOD = 0;
								decoupage_JPEG();
								calcul_TOTALGOOD();
							}
							save_hiscore();
						}
						Stylus.Newpress = false;
						PA_WaitForVBL();
					}
				}
				//*********************************************
				//*** GALLERY  ***
				//****************
				else if ( PA_StylusInZone(192,32,255,47) )
				{
					gallery = LEVEL;//syncho avec le visualiseur sur le menu
					aff_gallery_oui();
					voice_images();
					temporisation(15);
					aff_gallery_non();

					effacer_texte(0);

					startmenu = 3;

					//par dfaut, ds qu'on arrive ici
					//bg_grille = 0 Masqu
					//bg_info = 1 Visible
					bg_grille = 0;
					bg_info = 1;

					PA_OutputText(0, 0, 23, "no");//grille off
					PA_OutputText(0, 2, 23, "#####bc##%02d/20##de##########fg",gallery+1);//ecran, Colonne X, Ligne Y
					affichage_JPEG_gallery(gallery);

					while (startmenu == 3)
					{
						if (Pad.Newpress.X) {gestion_musique(); Pad.Newpress.X = false;}

						if (Stylus.Newpress || Pad.Newpress.Left || Pad.Newpress.Start || Pad.Newpress.Right || Pad.Newpress.L || Pad.Newpress.R)
						{
							if (Pad.Newpress.Left || (Stylus.Newpress && PA_StylusInZone(57,184,69,191)) )
							{
								Stylus.X = 0; Stylus.Y = 0;
								Pad.Newpress.Left = false;

								gallery--;
								if (gallery < 0)
								{
									gallery = 0;
									son_bad();
								}
								else
								{
									son_clik();
									if (bg_info == 1) {PA_OutputSimpleText(0, 7, 23, "hi");}
									affichage_JPEG_gallery(gallery);
									if (bg_info == 1) {PA_OutputText(0, 2, 23, "#####bc##%02d/20##de##########fg",gallery+1);}//ecran, Colonne X, Ligne Y
								}
							}
							else if (Pad.Newpress.Right || (Stylus.Newpress && PA_StylusInZone(146,184,158,191)) )
							{
								Stylus.X = 0; Stylus.Y = 0;
								Pad.Newpress.Right = false;

								gallery++;
								if (hiscore[WORLD][gallery].ETAT == 0 && gallery < LEVELMAX)
								{
									son_bad();
									//LOCK
									gallery--;
									if (bg_info == 1) {PA_OutputSimpleText(0, 18, 23, "de##LOCK");}

								}
								else if (gallery >= LEVELMAX)
								{
									son_bad();
									gallery = LEVELMAX - 1;
								}
								else
								{
									son_clik();
									if (bg_info == 1) {PA_OutputSimpleText(0, 18, 23, "jk");}
									affichage_JPEG_gallery(gallery);
									if (bg_info == 1) {PA_OutputText(0, 2, 23, "#####bc##%02d/20##de##########fg",gallery+1);}//ecran, Colonne X, Ligne Y
								}
							}
							else if (Pad.Newpress.Start || (Stylus.Newpress && PA_StylusInZone(240,184,255,191)) )
							{
								son_quitter();
								Stylus.X = 0; Stylus.Y = 0;
								Pad.Newpress.Start  = false;

								//Quitter
								startmenu = 2;
								bg_grille = 0; masquer_grille();
								LEVEL = gallery;//syncho avec le visualiseur sur le menu

								if (bg_info == 1) {PA_OutputSimpleText(0, 30, 23, "lm");}
								affichage_menu();
								if (bg_info == 1) {PA_OutputText(0, 0, 23, "%s",txtVIDE);}//ecran, Colonne X, Ligne Y

								bg_info = 1;
							}
							else if (Pad.Newpress.L || (Stylus.Newpress && PA_StylusInZone(0,184,16,191)) )
							{
								son_grille();
								Stylus.X = 0; Stylus.Y = 0;
								Pad.Newpress.L = false;
								if (bg_grille == 0)
								{
									if (bg_info == 1) {PA_OutputText(0, 0, 23, "pq");}
									bg_grille = 1;
									aff_grille();
								}
								else
								{
									if (bg_info == 1) {PA_OutputText(0, 0, 23, "no");}
									bg_grille = 0;
									masquer_grille();
								}
							}
							else if (Pad.Newpress.R)
							{
								son_info();
								Stylus.X = 0; Stylus.Y = 0;
								if (bg_info == 1)
								{
									//devient invisible
									bg_info = 0;
									masquer_info();
								}
								else
								{
									//visible
									bg_info = 1;
									if (bg_grille == 0)
									{
										PA_OutputText(0, 0, 23, "no");//grille off
									}
									else
									{
										PA_OutputText(0, 0, 23, "pq");//grille off
									}
									PA_OutputText(0, 2, 23, "#####bc##%02d/20##de##########fg",gallery+1);//ecran, Colonne X, Ligne Y
								}
								Pad.Newpress.R = false;
							}

							Stylus.Newpress = false;
							PA_WaitForVBL();
						}
						PA_WaitForVBL();
					}
				}
				//*********************************************
				//*** HELP ***
				//************
				else if ( PA_StylusInZone(192,72,255,87) )
				{
					aff_help_oui();
					voice_help();
					temporisation(15);
					aff_help_non();
					effacer_texte(0);
					affichage_JPEG_prs(1);
					pause();
					affichage_menu();
				}
				//*********************************************
				//*** INFOS ***
				//*************
				else if ( PA_StylusInZone(192,96,255,111) )
				{
					aff_infos_oui();
					voice_info();
					temporisation(15);
					aff_infos_non();
					effacer_texte(0);
					affichage_JPEG_prs(0);
					pause();
					affichage_menu();
				}
				Stylus.Newpress = false;
				Stylus.X = 256; Stylus.Y = 0;
			}
			PA_WaitForVBL();

		}
	}
	return 0;
}

